// OBCSDKEVCsampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OBCSDKEVCsample.h"
#include "OBCSDKEVCsampleDlg.h"
#include "OBCSDKEVC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define WM_USER_WHILEKEY_UP (WM_APP+300)
#define WM_USER_WHILEKEY_DOWN (WM_APP+301)
#define WM_USER_INPUTMODE (WM_APP+103)
/////////////////////////////////////////////////////////////////////////////
// COBCSDKEVCsampleDlg dialog

COBCSDKEVCsampleDlg::COBCSDKEVCsampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COBCSDKEVCsampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COBCSDKEVCsampleDlg)
	m_CMD = _T("");
	m_ScanData = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COBCSDKEVCsampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COBCSDKEVCsampleDlg)
	DDX_Control(pDX, IDC_INPUTMODE, m_InputMode);
	DDX_Control(pDX, IDC_LCDBKlight, m_LCDBKlight);
	DDX_Text(pDX, IDC_EDITCMD, m_CMD);
	DDX_Text(pDX, IDC_ScanData, m_ScanData);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COBCSDKEVCsampleDlg, CDialog)
	//{{AFX_MSG_MAP(COBCSDKEVCsampleDlg)
	ON_BN_CLICKED(IDC_SCAN, OnScan)
	ON_BN_CLICKED(IDC_DisBCT, OnDisBCT)
	ON_BN_CLICKED(IDC_EnBCT, OnEnBCT)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_MaskScankey, OnMaskScankey)
	ON_BN_CLICKED(IDC_UnMaskScankey, OnUnMaskScankey)
	ON_BN_CLICKED(IDC_Apply, OnApply)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_INPUTMODE, OnSelchangeInputmode)
	//}}AFX_MSG_MAP
	ON_MESSAGE ( WM_BCS_NOTIFY , ScanProcess_Notify )
	ON_MESSAGE ( WM_USER_WHILEKEY_UP , WhileKeyUP )
	ON_MESSAGE ( WM_USER_WHILEKEY_DOWN , WhileKeyDOWN )
	ON_MESSAGE ( WM_USER_INPUTMODE , InputModeChagne )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COBCSDKEVCsampleDlg message handlers

BOOL COBCSDKEVCsampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	char SN[20];
	char CN[20];
	WCHAR WSn[20];
	WCHAR Wcn[20];
	BYTE InputMode;
	memset(SN,9,20);

	//Get Serial Number
	BCT_GetSerialNumber(SN);
    MultiByteToWideChar(CP_ACP, 0, SN, -1, WSn, sizeof(SN));
	SetDlgItemText(IDC_SerialNo, WSn);
	//Get Configuration Number
	BCT_GetConfigurationNumber(CN);
    MultiByteToWideChar(CP_ACP, 0, CN, -1, Wcn, sizeof(CN));
	SetDlgItemText(IDC_CN, Wcn);

	// TODO: Add extra initialization here
	m_LCDBKlight.SetRange(0, 6);
	m_LCDBKlight.SetTicFreq(1);
	m_LCDBKlight.SetPos(BCT_LCDGetBacklight());


	m_InputMode.AddString(L"Mormal");
	m_InputMode.AddString(L"Alpha");
	m_InputMode.AddString(L"FN");
	
	InputMode = Get_INPUT_MODE();

	m_InputMode.SetCurSel((INT)InputMode);
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void COBCSDKEVCsampleDlg::OnScan() 
{
	BCT_BarCodeScan();	
}

void COBCSDKEVCsampleDlg::OnDisBCT() 
{
	BCT_OnOff_SDK(true);
	
}

void COBCSDKEVCsampleDlg::OnEnBCT() 
{
	BCT_OnOff_SDK(false);
	
}

void COBCSDKEVCsampleDlg::OnSend() 
{
/*    TCHAR buff[MAX_PATH];
	BCT_ShowVersion(buff);
	m_Data = buff;
	m_CMD = buff;
	UpdateData(false);
*/
UpdateData(true);
BYTE buff[MAX_PATH];
memset(buff,0,MAX_PATH);
buff[0]= 0x1b;
buff[m_CMD.GetLength()+1] = 0x0d;
	for(int i = 1;i<=m_CMD.GetLength(); i++)
	{
				buff[i] = (CHAR)m_CMD[i-1];

	}

BCT_Send_CMD(buff);
}

void COBCSDKEVCsampleDlg::OnMaskScankey() 
{
BCT_MaskBarCodeKeyWEDGE();
}

void COBCSDKEVCsampleDlg::OnUnMaskScankey() 
{
BCT_UnMaskBarCodeKeyWEDGE();	
}

void COBCSDKEVCsampleDlg::ScanProcess_Notify ( WPARAM wParam, LPARAM lParam )
{
   BYTE barcodeStr[MAX_PATH];

   memset(barcodeStr,0,MAX_PATH);
   int ScanStatus;
   int Len = 0;
	int i = 0;	


   BCT_GetBarCode(barcodeStr,&ScanStatus,&Len);
   
   
   switch(ScanStatus)
         {
          case BarCodeRead_OK:                             

               m_ScanData=barcodeStr;
		//	   m_ScanData =  Len;
		//	   m_Lenth = Len;
			
			   for(i = 0; i<Len;i++)
			   {
				printf("Data[%d] = %d\r\n",i,barcodeStr[i]);

			   }
				UpdateData(FALSE);	
               break;
  /*        
          case BarCodeRead_Timeout:
               
               m_ScanData=L"Scan Timout";               
             
               break;
          
          case BarCodeRead_NotReady:
          
               m_ScanData=L"Device is not ready";     
               break;
        
          case BarCodeRead_Disable:
               m_ScanData=L"Scanner is disable";     
               break;
          
          case BarCodeRead_ForceStop:
               m_ScanData=L"Force Stop";     
               break;
          
          case BarCodeRead_Scanning:
               m_ScanData=L"Scanning";     
               break;
          
          case BarCodeRead_Continuous:
               m_ScanData=L"Continuous";     
               break;
         */ 
          
          default:break;                                    
         
         
         }
   
    UpdateData(FALSE);  
   
}

void COBCSDKEVCsampleDlg::OnApply() 
{

	switch(GetCheckedRadioButton(IDC_EnableBCT,IDC_DisableBCT))
	{
	case IDC_EnableBCT:
		BCT_OnOff_SDK(false);
		break;
	case IDC_DisableBCT:
		BCT_OnOff_SDK(true);
		break;
	}

	switch(GetCheckedRadioButton(IDC_Mask,IDC_UnMask))
	{
	case IDC_Mask:
		BCT_MaskBarCodeKeyWEDGE();
		break;
	case IDC_UnMask:
		BCT_UnMaskBarCodeKeyWEDGE();
		break;
	}
	
   if(BST_UNCHECKED==SendDlgItemMessage( IDC_ScanMsg, BM_GETCHECK, 0, 0))
	   BCT_EnableKeyNotification(Ctl_ScanKey_Notify);
   else
	   BCT_DisableKeyNotification(Ctl_ScanKey_Notify);

   if(BST_UNCHECKED==SendDlgItemMessage( IDC_FnMsg, BM_GETCHECK, 0, 0))
	   BCT_EnableKeyNotification(Ctl_FnKey_Notify);
   else
	   BCT_DisableKeyNotification(Ctl_FnKey_Notify);

   if(BST_UNCHECKED==SendDlgItemMessage( IDC_AlphaMsg, BM_GETCHECK, 0, 0))
	   BCT_EnableKeyNotification(Ctl_AlphaKey_Notify);
   else
	   BCT_DisableKeyNotification(Ctl_AlphaKey_Notify);   
}



void COBCSDKEVCsampleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int pos = m_LCDBKlight.GetPos();
	BCT_LCDSetBacklight(pos);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
void COBCSDKEVCsampleDlg::WhileKeyDOWN(WPARAM wParam, LPARAM lParam )
{
AfxMessageBox(L"WhileKeyDOWN");
}
void COBCSDKEVCsampleDlg::WhileKeyUP(WPARAM wParam, LPARAM lParam )
{
AfxMessageBox(L"WhileKeyUP");
}

void COBCSDKEVCsampleDlg::InputModeChagne(WPARAM wParam, LPARAM lParam)
{
	AfxMessageBox(L"InputModeChagne");
}

void COBCSDKEVCsampleDlg::OnSelchangeInputmode() 
{
		int Value = m_InputMode.GetCurSel();
		Set_INPUT_MODE((BYTE)Value);
}
