using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using PHL7000;


namespace PHL7000Sample
{
	/// <summary>
	/// PH7KForm KnyzC
	/// </summary>
	public class PH7KForm : System.Windows.Forms.Form
	{
		private PHL7000.LCD phl7kLCD;
		private PHL7000.KEYPAD phl7kKPD;
		private PHL7000.BARCODE phl7kBC;
		private PHL7000.PHL7000 phl7k;

		private System.Windows.Forms.TabControl tabControlMainPage;
		private System.Windows.Forms.TrackBar trackBarLCD;
		private System.Windows.Forms.Label label_LCD;
		private System.Windows.Forms.TabPage tabPageKPD;
		private System.Windows.Forms.TabPage tabPageBarcode;
		private System.Windows.Forms.Button button_Barcode_Scan;
		private System.Windows.Forms.ListBox listBoxBarcodeData;
		private System.Windows.Forms.StatusBar statusBarPHL7K;
		private System.Windows.Forms.TabPage tabPagePHL7000;
		private System.Windows.Forms.Button buttonReset;
		private System.Windows.Forms.TextBox textBoxSN;
		private System.Windows.Forms.TextBox textBoxCN;
		private System.Windows.Forms.Label labelSN;
		private System.Windows.Forms.Label labelCN;
		private System.Windows.Forms.TrackBar trackBarMIC;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox checkBoxVOL;
		private System.Windows.Forms.TrackBar trackBarVOL;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox textBoxVER;
		private System.Windows.Forms.ListBox listBoxKPDEvent;
		private System.Windows.Forms.CheckBox checkBoxFnUp;
		private System.Windows.Forms.CheckBox checkBoxFnDown;
		private System.Windows.Forms.CheckBox checkBoxAlphaUp;
		private System.Windows.Forms.CheckBox checkBoxAlphaDown;
		private System.Windows.Forms.CheckBox checkBoxKPDBacklight;
		private System.Windows.Forms.Label labelBarcodefwString;
		private System.Windows.Forms.TextBox textBoxBarcodeFwString;
		private System.Windows.Forms.CheckBox checkBoxScanUp;
		private System.Windows.Forms.CheckBox checkBoxScanDown;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ComboBox comboBoxInputMode;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TabPage tabPageLCD;
	
		public PH7KForm()
		{
			//
			// Windows Form ]pu䴩n
			//
			InitializeComponent();


			///////////////////////////////////////////////////////////////////
			/// LCD function Initialization
			/////////////////////////////////////////////////////////////////// 
			phl7kLCD = new LCD();
			this.trackBarLCD.Value = phl7kLCD.LCD_BKLIGHT;



			///////////////////////////////////////////////////////////////////
			/// KPD function Initialization
			/////////////////////////////////////////////////////////////////// 
			phl7kKPD = new KEYPAD();

			if( phl7kKPD.KEYPAD_BKLIGHT )
				this.checkBoxKPDBacklight.Checked = true;
			else
				this.checkBoxKPDBacklight.Checked = false;

			comboBoxInputMode.SelectedIndex = (int)phl7kKPD.Input_Mode;
			///////////////////////////////////////////////////////////////////
			/// Barcode function Initialization
			/////////////////////////////////////////////////////////////////// 
			phl7kBC = new BARCODE();
			phl7kBC.DataHandler += new EventHandler(phl7kBC_DataHandler);
			this.textBoxBarcodeFwString.Text = this.phl7kBC.FwVersion;
			
			///////////////////////////////////////////////////////////////////
			/// PHL7000 function Initialization
			/////////////////////////////////////////////////////////////////// 
			phl7k = new PHL7000.PHL7000();
			this.textBoxVER.Text = phl7k.Version;
			this.textBoxSN.Text = phl7k.SerialNumber;
			this.textBoxCN.Text = phl7k.ConfigurationNumber;

			/// Set the Micphone and Volume 
			this.trackBarMIC.Value = phl7k.MIC_Gain;
			this.trackBarVOL.Value = phl7k.VOLUME;


		}
		/// <summary>
		/// MϥΤ귽C
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form ]pu㲣ͪ{X
		/// <summary>
		/// ]pu䴩ҥk - ФŨϥε{Xs边ק
		/// oӤkeC
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControlMainPage = new System.Windows.Forms.TabControl();
			this.tabPageLCD = new System.Windows.Forms.TabPage();
			this.label_LCD = new System.Windows.Forms.Label();
			this.trackBarLCD = new System.Windows.Forms.TrackBar();
			this.tabPageBarcode = new System.Windows.Forms.TabPage();
			this.button1 = new System.Windows.Forms.Button();
			this.labelBarcodefwString = new System.Windows.Forms.Label();
			this.textBoxBarcodeFwString = new System.Windows.Forms.TextBox();
			this.listBoxBarcodeData = new System.Windows.Forms.ListBox();
			this.button_Barcode_Scan = new System.Windows.Forms.Button();
			this.tabPageKPD = new System.Windows.Forms.TabPage();
			this.checkBoxKPDBacklight = new System.Windows.Forms.CheckBox();
			this.checkBoxAlphaUp = new System.Windows.Forms.CheckBox();
			this.checkBoxAlphaDown = new System.Windows.Forms.CheckBox();
			this.checkBoxFnUp = new System.Windows.Forms.CheckBox();
			this.checkBoxFnDown = new System.Windows.Forms.CheckBox();
			this.checkBoxScanUp = new System.Windows.Forms.CheckBox();
			this.listBoxKPDEvent = new System.Windows.Forms.ListBox();
			this.checkBoxScanDown = new System.Windows.Forms.CheckBox();
			this.tabPagePHL7000 = new System.Windows.Forms.TabPage();
			this.checkBoxVOL = new System.Windows.Forms.CheckBox();
			this.trackBarMIC = new System.Windows.Forms.TrackBar();
			this.labelSN = new System.Windows.Forms.Label();
			this.textBoxSN = new System.Windows.Forms.TextBox();
			this.buttonReset = new System.Windows.Forms.Button();
			this.textBoxCN = new System.Windows.Forms.TextBox();
			this.labelCN = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.trackBarVOL = new System.Windows.Forms.TrackBar();
			this.label2 = new System.Windows.Forms.Label();
			this.textBoxVER = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.statusBarPHL7K = new System.Windows.Forms.StatusBar();
			this.comboBoxInputMode = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			// 
			// tabControlMainPage
			// 
			this.tabControlMainPage.Controls.Add(this.tabPageLCD);
			this.tabControlMainPage.Controls.Add(this.tabPageKPD);
			this.tabControlMainPage.Controls.Add(this.tabPageBarcode);
			this.tabControlMainPage.Controls.Add(this.tabPagePHL7000);
			this.tabControlMainPage.SelectedIndex = 0;
			this.tabControlMainPage.Size = new System.Drawing.Size(240, 248);
			this.tabControlMainPage.SelectedIndexChanged += new System.EventHandler(this.tabControlMainPage_SelectedIndexChanged);
			// 
			// tabPageLCD
			// 
			this.tabPageLCD.Controls.Add(this.label_LCD);
			this.tabPageLCD.Controls.Add(this.trackBarLCD);
			this.tabPageLCD.Location = new System.Drawing.Point(4, 28);
			this.tabPageLCD.Size = new System.Drawing.Size(232, 216);
			this.tabPageLCD.Text = "LCD";
			// 
			// label_LCD
			// 
			this.label_LCD.Location = new System.Drawing.Point(16, 32);
			this.label_LCD.Text = "LCD";
			// 
			// trackBarLCD
			// 
			this.trackBarLCD.LargeChange = 1;
			this.trackBarLCD.Location = new System.Drawing.Point(16, 88);
			this.trackBarLCD.Maximum = 6;
			this.trackBarLCD.Size = new System.Drawing.Size(192, 56);
			this.trackBarLCD.ValueChanged += new System.EventHandler(this.trackBarLCD_ValueChanged);
			// 
			// tabPageBarcode
			// 
			this.tabPageBarcode.Controls.Add(this.button1);
			this.tabPageBarcode.Controls.Add(this.labelBarcodefwString);
			this.tabPageBarcode.Controls.Add(this.textBoxBarcodeFwString);
			this.tabPageBarcode.Controls.Add(this.listBoxBarcodeData);
			this.tabPageBarcode.Controls.Add(this.button_Barcode_Scan);
			this.tabPageBarcode.Location = new System.Drawing.Point(4, 24);
			this.tabPageBarcode.Size = new System.Drawing.Size(232, 220);
			this.tabPageBarcode.Text = "BARCODE";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(136, 176);
			this.button1.Size = new System.Drawing.Size(72, 32);
			this.button1.Text = "Clean";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// labelBarcodefwString
			// 
			this.labelBarcodefwString.Location = new System.Drawing.Point(16, 8);
			this.labelBarcodefwString.Size = new System.Drawing.Size(56, 24);
			this.labelBarcodefwString.Text = "Version";
			this.labelBarcodefwString.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// textBoxBarcodeFwString
			// 
			this.textBoxBarcodeFwString.Location = new System.Drawing.Point(80, 8);
			this.textBoxBarcodeFwString.ReadOnly = true;
			this.textBoxBarcodeFwString.Size = new System.Drawing.Size(136, 27);
			this.textBoxBarcodeFwString.Text = "";
			// 
			// listBoxBarcodeData
			// 
			this.listBoxBarcodeData.Font = new System.Drawing.Font("Verdana", 9F, System.Drawing.FontStyle.Regular);
			this.listBoxBarcodeData.Location = new System.Drawing.Point(24, 48);
			this.listBoxBarcodeData.Size = new System.Drawing.Size(184, 110);
			// 
			// button_Barcode_Scan
			// 
			this.button_Barcode_Scan.Location = new System.Drawing.Point(24, 176);
			this.button_Barcode_Scan.Size = new System.Drawing.Size(88, 32);
			this.button_Barcode_Scan.Text = "Scan";
			this.button_Barcode_Scan.Click += new System.EventHandler(this.button_Barcode_Scan_Click);
			// 
			// tabPageKPD
			// 
			this.tabPageKPD.Controls.Add(this.label4);
			this.tabPageKPD.Controls.Add(this.comboBoxInputMode);
			this.tabPageKPD.Controls.Add(this.checkBoxKPDBacklight);
			this.tabPageKPD.Controls.Add(this.checkBoxAlphaUp);
			this.tabPageKPD.Controls.Add(this.checkBoxAlphaDown);
			this.tabPageKPD.Controls.Add(this.checkBoxFnUp);
			this.tabPageKPD.Controls.Add(this.checkBoxFnDown);
			this.tabPageKPD.Controls.Add(this.checkBoxScanUp);
			this.tabPageKPD.Controls.Add(this.listBoxKPDEvent);
			this.tabPageKPD.Controls.Add(this.checkBoxScanDown);
			this.tabPageKPD.Location = new System.Drawing.Point(4, 28);
			this.tabPageKPD.Size = new System.Drawing.Size(232, 216);
			this.tabPageKPD.Text = "KPD";
			// 
			// checkBoxKPDBacklight
			// 
			this.checkBoxKPDBacklight.Location = new System.Drawing.Point(8, 8);
			this.checkBoxKPDBacklight.Text = "Backlight";
			this.checkBoxKPDBacklight.CheckStateChanged += new System.EventHandler(this.checkBoxKPDBacklight_CheckStateChanged);
			// 
			// checkBoxAlphaUp
			// 
			this.checkBoxAlphaUp.Location = new System.Drawing.Point(8, 160);
			this.checkBoxAlphaUp.Size = new System.Drawing.Size(96, 20);
			this.checkBoxAlphaUp.Text = "AlphaUp";
			this.checkBoxAlphaUp.CheckStateChanged += new System.EventHandler(this.checkBoxAlphaUp_CheckStateChanged);
			// 
			// checkBoxAlphaDown
			// 
			this.checkBoxAlphaDown.Location = new System.Drawing.Point(8, 144);
			this.checkBoxAlphaDown.Size = new System.Drawing.Size(96, 20);
			this.checkBoxAlphaDown.Text = "AlphaDown";
			this.checkBoxAlphaDown.CheckStateChanged += new System.EventHandler(this.checkBoxAlphaDown_CheckStateChanged);
			// 
			// checkBoxFnUp
			// 
			this.checkBoxFnUp.Location = new System.Drawing.Point(8, 112);
			this.checkBoxFnUp.Size = new System.Drawing.Size(56, 20);
			this.checkBoxFnUp.Text = "FnUp";
			this.checkBoxFnUp.CheckStateChanged += new System.EventHandler(this.checkBoxFnUp_CheckStateChanged);
			// 
			// checkBoxFnDown
			// 
			this.checkBoxFnDown.Location = new System.Drawing.Point(8, 96);
			this.checkBoxFnDown.Size = new System.Drawing.Size(72, 20);
			this.checkBoxFnDown.Text = "FnDown";
			this.checkBoxFnDown.CheckStateChanged += new System.EventHandler(this.checkBoxFnDown_CheckStateChanged);
			// 
			// checkBoxScanUp
			// 
			this.checkBoxScanUp.Location = new System.Drawing.Point(8, 64);
			this.checkBoxScanUp.Size = new System.Drawing.Size(88, 20);
			this.checkBoxScanUp.Text = "ScanUp";
			this.checkBoxScanUp.CheckStateChanged += new System.EventHandler(this.checkBoxScanUp_CheckStateChanged);
			// 
			// listBoxKPDEvent
			// 
			this.listBoxKPDEvent.Location = new System.Drawing.Point(104, 8);
			this.listBoxKPDEvent.Size = new System.Drawing.Size(120, 135);
			// 
			// checkBoxScanDown
			// 
			this.checkBoxScanDown.Location = new System.Drawing.Point(8, 48);
			this.checkBoxScanDown.Text = "ScanDown";
			this.checkBoxScanDown.CheckStateChanged += new System.EventHandler(this.checkBoxScanDown_CheckStateChanged);
			// 
			// tabPagePHL7000
			// 
			this.tabPagePHL7000.Controls.Add(this.checkBoxVOL);
			this.tabPagePHL7000.Controls.Add(this.trackBarMIC);
			this.tabPagePHL7000.Controls.Add(this.labelSN);
			this.tabPagePHL7000.Controls.Add(this.textBoxSN);
			this.tabPagePHL7000.Controls.Add(this.buttonReset);
			this.tabPagePHL7000.Controls.Add(this.textBoxCN);
			this.tabPagePHL7000.Controls.Add(this.labelCN);
			this.tabPagePHL7000.Controls.Add(this.label1);
			this.tabPagePHL7000.Controls.Add(this.trackBarVOL);
			this.tabPagePHL7000.Controls.Add(this.label2);
			this.tabPagePHL7000.Controls.Add(this.textBoxVER);
			this.tabPagePHL7000.Controls.Add(this.label3);
			this.tabPagePHL7000.Location = new System.Drawing.Point(4, 24);
			this.tabPagePHL7000.Size = new System.Drawing.Size(232, 220);
			this.tabPagePHL7000.Text = "PHL7000";
			// 
			// checkBoxVOL
			// 
			this.checkBoxVOL.Location = new System.Drawing.Point(8, 176);
			this.checkBoxVOL.Size = new System.Drawing.Size(64, 24);
			this.checkBoxVOL.Text = "MUTE";
			this.checkBoxVOL.CheckStateChanged += new System.EventHandler(this.checkBoxVOL_CheckStateChanged);
			// 
			// trackBarMIC
			// 
			this.trackBarMIC.Location = new System.Drawing.Point(40, 104);
			this.trackBarMIC.Maximum = 255;
			this.trackBarMIC.Size = new System.Drawing.Size(176, 32);
			this.trackBarMIC.TickFrequency = 16;
			this.trackBarMIC.ValueChanged += new System.EventHandler(this.trackBarMIC_ValueChanged);
			// 
			// labelSN
			// 
			this.labelSN.Location = new System.Drawing.Point(8, 40);
			this.labelSN.Size = new System.Drawing.Size(32, 20);
			this.labelSN.Text = "SN:";
			// 
			// textBoxSN
			// 
			this.textBoxSN.Location = new System.Drawing.Point(40, 40);
			this.textBoxSN.ReadOnly = true;
			this.textBoxSN.Size = new System.Drawing.Size(96, 27);
			this.textBoxSN.Text = "";
			// 
			// buttonReset
			// 
			this.buttonReset.Location = new System.Drawing.Point(136, 176);
			this.buttonReset.Size = new System.Drawing.Size(80, 32);
			this.buttonReset.Text = "RESET";
			this.buttonReset.Click += new System.EventHandler(this.buttonReset_Click);
			// 
			// textBoxCN
			// 
			this.textBoxCN.Location = new System.Drawing.Point(40, 72);
			this.textBoxCN.ReadOnly = true;
			this.textBoxCN.Size = new System.Drawing.Size(96, 27);
			this.textBoxCN.Text = "";
			// 
			// labelCN
			// 
			this.labelCN.Location = new System.Drawing.Point(8, 72);
			this.labelCN.Size = new System.Drawing.Size(32, 20);
			this.labelCN.Text = "CN:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 104);
			this.label1.Size = new System.Drawing.Size(40, 20);
			this.label1.Text = "MIC:";
			// 
			// trackBarVOL
			// 
			this.trackBarVOL.LargeChange = 4096;
			this.trackBarVOL.Location = new System.Drawing.Point(40, 136);
			this.trackBarVOL.Maximum = 65535;
			this.trackBarVOL.Size = new System.Drawing.Size(176, 45);
			this.trackBarVOL.SmallChange = 4096;
			this.trackBarVOL.TickFrequency = 4096;
			this.trackBarVOL.ValueChanged += new System.EventHandler(this.trackBarVOL_ValueChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 144);
			this.label2.Size = new System.Drawing.Size(40, 20);
			this.label2.Text = "VOL:";
			// 
			// textBoxVER
			// 
			this.textBoxVER.Location = new System.Drawing.Point(40, 8);
			this.textBoxVER.ReadOnly = true;
			this.textBoxVER.Size = new System.Drawing.Size(96, 27);
			this.textBoxVER.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 8);
			this.label3.Size = new System.Drawing.Size(32, 20);
			this.label3.Text = "VER";
			// 
			// statusBarPHL7K
			// 
			this.statusBarPHL7K.Location = new System.Drawing.Point(0, 244);
			this.statusBarPHL7K.Size = new System.Drawing.Size(234, 22);
			// 
			// comboBoxInputMode
			// 
			this.comboBoxInputMode.Items.Add("Nromal");
			this.comboBoxInputMode.Items.Add("Alpha");
			this.comboBoxInputMode.Items.Add("Fn");
			this.comboBoxInputMode.Location = new System.Drawing.Point(112, 176);
			this.comboBoxInputMode.SelectedIndexChanged += new System.EventHandler(this.comboBoxInputMode_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(112, 152);
			this.label4.Text = "InputMode";
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			// 
			// PH7KForm
			// 
			this.ClientSize = new System.Drawing.Size(234, 266);
			this.Controls.Add(this.statusBarPHL7K);
			this.Controls.Add(this.tabControlMainPage);
			this.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular);
			this.Text = "PHL7000";

		}
		#endregion

		/// <summary>
		/// ε{DiJIC
		/// </summary>

		static void Main() 
		{
			Application.Run(new PH7KForm());
		}

		//************************************************************************************
		// Sampe Code for LCD
		//************************************************************************************

		private void trackBarLCD_ValueChanged(object sender, System.EventArgs e)
		{
			this.phl7kLCD.LCD_BKLIGHT = this.trackBarLCD.Value;
		}

		//************************************************************************************
		// Sampe Code for PHL7000
		//************************************************************************************
		private void buttonReset_Click(object sender, System.EventArgs e)
		{
			this.phl7k.Reboot();
		}

		private void trackBarMIC_ValueChanged(object sender, System.EventArgs e)
		{
			this.phl7k.MIC_Gain = this.trackBarMIC.Value;
		}


		private void checkBoxVOL_CheckStateChanged(object sender, System.EventArgs e)
		{
			if( this.checkBoxVOL.Checked )
				this.phl7k.MUTE = true;
			else
				this.phl7k.MUTE = false;
		}

		private void trackBarVOL_ValueChanged(object sender, System.EventArgs e)
		{
			this.phl7k.VOLUME = this.trackBarVOL.Value;
		}

		//************************************************************************************
		// Sampe Code for BARCODE
		//************************************************************************************
		private void button_Barcode_Scan_Click(object sender, System.EventArgs e)
		{
			this.statusBarPHL7K.Text = "Scanning...";
			this.Update();
			this.Focus();
			
			this.phl7kBC.Scan();
		}

		private void phl7kBC_DataHandler(object sender, EventArgs e)
		{
			int i = 0;
			int lenth = 0;
			byte[] data = new byte[1024];

		//	if( this.listBoxBarcodeData.Items.Count > 8 )
		//		this.listBoxBarcodeData.Items.Clear();

			this.listBoxBarcodeData.Items.Add( this.phl7kBC.BARCODEData );
			this.statusBarPHL7K.Text = "Successful";

			data = this.phl7kBC.BARCODEDataByte;
			lenth = this.phl7kBC.BARCODEByteLen;
			MessageBox.Show(lenth.ToString());
			for(i=0;i<lenth;i++)
			{
				this.listBoxBarcodeData.Items.Add(data.GetValue(i));
			}
		}

		//************************************************************************************
		// Sampe Code for KEYPAD
		//************************************************************************************

		private void checkBoxKPDBacklight_CheckStateChanged(object sender, System.EventArgs e)
		{
			if( this.checkBoxKPDBacklight.Checked == true )
				phl7kKPD.KEYPAD_BKLIGHT = true;
			else
				phl7kKPD.KEYPAD_BKLIGHT = false;
		}

		#region Scan Key Down
		private void checkBoxScanDown_CheckStateChanged(object sender, System.EventArgs e)
		{
			if( this.checkBoxScanDown.Checked )
				phl7kKPD.ScanKeyDownHandler += new EventHandler( phl7kKPD_ScanKeyDownHandler );
			else
				phl7kKPD.ScanKeyDownHandler -= new EventHandler( phl7kKPD_ScanKeyDownHandler );
		}

		private void phl7kKPD_ScanKeyDownHandler(object sender, EventArgs e)
		{
			if( this.listBoxKPDEvent.Items.Count > 8 )
				this.listBoxKPDEvent.Items.Clear();

			this.listBoxKPDEvent.Items.Add( "Scan Key Down");
		}
		#endregion Scan Key Down

		#region Scan Key Up
		private void checkBoxScanUp_CheckStateChanged(object sender, System.EventArgs e)
		{
			if( this.checkBoxScanUp.Checked )
				phl7kKPD.ScanKeyUpHandler += new EventHandler(phl7kKPD_ScanKeyUpHandler);
			else
				phl7kKPD.ScanKeyUpHandler -= new EventHandler(phl7kKPD_ScanKeyUpHandler);
		}


		private void phl7kKPD_ScanKeyUpHandler(object sender, EventArgs e)
		{
			if( this.listBoxKPDEvent.Items.Count > 8 )
				this.listBoxKPDEvent.Items.Clear();

			this.listBoxKPDEvent.Items.Add( "Scan Key Up");
		}

		#endregion Scan KeyUP


		#region Function Key Down
		private void checkBoxFnDown_CheckStateChanged(object sender, System.EventArgs e)
		{
			if( this.checkBoxFnDown.Checked )
				phl7kKPD.FunctionKeyDownHandler += new EventHandler( phl7kKPD_FunctionKeyDownHandler );
			else
				phl7kKPD.FunctionKeyDownHandler -= new EventHandler( phl7kKPD_FunctionKeyDownHandler );

		}

		private void phl7kKPD_FunctionKeyDownHandler(object sender, EventArgs e)
		{
			if( this.listBoxKPDEvent.Items.Count > 8 )
				this.listBoxKPDEvent.Items.Clear();

			this.listBoxKPDEvent.Items.Add( "Function Key Down");
		}
		#endregion Function Key Down

		#region Function Key Up
		private void checkBoxFnUp_CheckStateChanged(object sender, System.EventArgs e)
		{

			if( this.checkBoxFnUp.Checked )
				phl7kKPD.FunctionKeyUpHandler += new EventHandler(phl7kKPD_FunctionKeyUpHandler);
			else
				phl7kKPD.FunctionKeyUpHandler -= new EventHandler(phl7kKPD_FunctionKeyUpHandler);

		}

		private void phl7kKPD_FunctionKeyUpHandler(object sender, EventArgs e)
		{	

			if( this.listBoxKPDEvent.Items.Count > 8 )
				this.listBoxKPDEvent.Items.Clear();

			this.listBoxKPDEvent.Items.Add( "Function Key Up");

		}
		#endregion Function Key Up


		#region Alpha Key Down
		private void checkBoxAlphaDown_CheckStateChanged(object sender, System.EventArgs e)
		{
			if( this.checkBoxAlphaDown.Checked )
				phl7kKPD.AlphaKeyDownHandler += new EventHandler(phl7kKPD_AlphaKeyDownHandler);
			else
				phl7kKPD.AlphaKeyDownHandler -= new EventHandler(phl7kKPD_AlphaKeyDownHandler);
		}

		private void phl7kKPD_AlphaKeyDownHandler(object sender, EventArgs e)
		{
			if( this.listBoxKPDEvent.Items.Count > 8 )
				this.listBoxKPDEvent.Items.Clear();

			this.listBoxKPDEvent.Items.Add( "Alpha Key Down");
		}
		#endregion Alpha Key Down

		#region Alpha Key Up
		private void checkBoxAlphaUp_CheckStateChanged(object sender, System.EventArgs e)
		{

			if( this.checkBoxAlphaUp.Checked )
				phl7kKPD.AlphaKeyUpHandler += new EventHandler(phl7kKPD_AlphaKeyUpHandler);
			else
				phl7kKPD.AlphaKeyUpHandler -= new EventHandler(phl7kKPD_AlphaKeyUpHandler);

		}

		private void phl7kKPD_AlphaKeyUpHandler(object sender, EventArgs e)
		{

			if( this.listBoxKPDEvent.Items.Count > 8 )
				this.listBoxKPDEvent.Items.Clear();

			this.listBoxKPDEvent.Items.Add( "Alpha Key Up");


		}
		#endregion Alpha Key Up

		private void tabControlMainPage_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.listBoxBarcodeData.Items.Clear();
		}

		private void comboBoxInputMode_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			 phl7kKPD.Input_Mode = (byte)comboBoxInputMode.SelectedIndex;

		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(phl7kKPD.Input_Mode.ToString());
		}


		
	}
}
